# autogenerated module
from typing import ClassVar

from ..core import resource as res
from ..models import apiregistration_v1 as m_apiregistration_v1


class APIServiceStatus(res.GlobalSubResource, m_apiregistration_v1.APIService):
    """* **Extends**: ``models.apiregistration_v1.APIService``
       * **Type**: Global Resource
       * **Accepted client methods**: `get`, `patch`, `replace`
    """
    _api_info = res.ApiInfo(
        resource=res.ResourceDef('apiregistration.k8s.io', 'v1', 'APIService'),
        parent=res.ResourceDef('apiregistration.k8s.io', 'v1', 'APIService'),
        plural='apiservices',
        verbs=['get', 'patch', 'put'],
        action='status',
    )


class APIService(res.GlobalResource, m_apiregistration_v1.APIService):
    """* **Extends**: ``models.apiregistration_v1.APIService``
       * **Type**: Global Resource
       * **Accepted client methods**: `delete`, `deletecollection`, `get`, `list`, `patch`, `create`, `replace`, `watch`

       **Subresources**:

       * **Status**: ``APIServiceStatus``
    """
    _api_info = res.ApiInfo(
        resource=res.ResourceDef('apiregistration.k8s.io', 'v1', 'APIService'),
        plural='apiservices',
        verbs=['delete', 'deletecollection', 'get', 'list', 'patch', 'post', 'put', 'watch'],
    )

    Status: ClassVar = APIServiceStatus

