# autogenerated module
from typing import ClassVar

from ..core import resource as res
from ..models import autoscaling_v1 as m_autoscaling_v1


class HorizontalPodAutoscalerStatus(res.NamespacedSubResource, m_autoscaling_v1.HorizontalPodAutoscaler):
    """* **Extends**: ``models.autoscaling_v1.HorizontalPodAutoscaler``
       * **Type**: Namespaced Resource
       * **Accepted client methods**: `get`, `patch`, `replace`
    """
    _api_info = res.ApiInfo(
        resource=res.ResourceDef('autoscaling', 'v1', 'HorizontalPodAutoscaler'),
        parent=res.ResourceDef('autoscaling', 'v1', 'HorizontalPodAutoscaler'),
        plural='horizontalpodautoscalers',
        verbs=['get', 'patch', 'put'],
        action='status',
    )


class HorizontalPodAutoscaler(res.NamespacedResourceG, m_autoscaling_v1.HorizontalPodAutoscaler):
    """* **Extends**: ``models.autoscaling_v1.HorizontalPodAutoscaler``
       * **Type**: Namespaced Resource
       * **Accepted client methods**: `delete`, `deletecollection`, `get`, `list` all, `watch` all, `list`, `patch`, `create`, `replace`, `watch`

       **Subresources**:

       * **Status**: ``HorizontalPodAutoscalerStatus``
    """
    _api_info = res.ApiInfo(
        resource=res.ResourceDef('autoscaling', 'v1', 'HorizontalPodAutoscaler'),
        plural='horizontalpodautoscalers',
        verbs=['delete', 'deletecollection', 'get', 'global_list', 'global_watch', 'list', 'patch', 'post', 'put', 'watch'],
    )

    Status: ClassVar = HorizontalPodAutoscalerStatus

