# autogenerated module
from typing import ClassVar

from ..core import resource as res
from ..models import batch_v1 as m_batch_v1


class CronJobStatus(res.NamespacedSubResource, m_batch_v1.CronJob):
    """* **Extends**: ``models.batch_v1.CronJob``
       * **Type**: Namespaced Resource
       * **Accepted client methods**: `get`, `patch`, `replace`
    """
    _api_info = res.ApiInfo(
        resource=res.ResourceDef('batch', 'v1', 'CronJob'),
        parent=res.ResourceDef('batch', 'v1', 'CronJob'),
        plural='cronjobs',
        verbs=['get', 'patch', 'put'],
        action='status',
    )


class CronJob(res.NamespacedResourceG, m_batch_v1.CronJob):
    """* **Extends**: ``models.batch_v1.CronJob``
       * **Type**: Namespaced Resource
       * **Accepted client methods**: `delete`, `deletecollection`, `get`, `list` all, `watch` all, `list`, `patch`, `create`, `replace`, `watch`

       **Subresources**:

       * **Status**: ``CronJobStatus``
    """
    _api_info = res.ApiInfo(
        resource=res.ResourceDef('batch', 'v1', 'CronJob'),
        plural='cronjobs',
        verbs=['delete', 'deletecollection', 'get', 'global_list', 'global_watch', 'list', 'patch', 'post', 'put', 'watch'],
    )

    Status: ClassVar = CronJobStatus


class JobStatus(res.NamespacedSubResource, m_batch_v1.Job):
    """* **Extends**: ``models.batch_v1.Job``
       * **Type**: Namespaced Resource
       * **Accepted client methods**: `get`, `patch`, `replace`
    """
    _api_info = res.ApiInfo(
        resource=res.ResourceDef('batch', 'v1', 'Job'),
        parent=res.ResourceDef('batch', 'v1', 'Job'),
        plural='jobs',
        verbs=['get', 'patch', 'put'],
        action='status',
    )


class Job(res.NamespacedResourceG, m_batch_v1.Job):
    """* **Extends**: ``models.batch_v1.Job``
       * **Type**: Namespaced Resource
       * **Accepted client methods**: `delete`, `deletecollection`, `get`, `list` all, `watch` all, `list`, `patch`, `create`, `replace`, `watch`

       **Subresources**:

       * **Status**: ``JobStatus``
    """
    _api_info = res.ApiInfo(
        resource=res.ResourceDef('batch', 'v1', 'Job'),
        plural='jobs',
        verbs=['delete', 'deletecollection', 'get', 'global_list', 'global_watch', 'list', 'patch', 'post', 'put', 'watch'],
    )

    Status: ClassVar = JobStatus

